# ProjectEuler

Problems are taken from https://projecteuler.net/.

Project Euler is a series of challenging mathematical/computer programming problems that will require more than just mathematical
insights to solve. Project Euler is ideal for mathematicians who are learning to code.

Here the efficiency of your code is also checked.
I've tried to provide all the best possible solutions.

PROBLEMS:

1. If we list all the natural numbers below 10 that are multiples of 3 or 5, we get 3,5,6 and 9. The sum of these multiples is 23.
   Find the sum of all the multiples of 3 or 5 below N.

2. Each new term in the Fibonacci sequence is generated by adding the previous two terms. By starting with 1 and 2,
   the first 10 terms will be:
      1,2,3,5,8,13,21,34,55,89,..
   By considering the terms in the Fibonacci sequence whose values do not exceed n, find the sum of the even-valued terms.  
   e.g. for n=10, we have {2,8}, sum is 10.

3. The prime factors of 13195 are 5,7,13 and 29. What is the largest prime factor of a given number N?
   e.g. for 10, largest prime factor = 5. For 17, largest prime factor = 17.

4. A palindromic number reads the same both ways. The largest palindrome made from the product of two 2-digit numbers is 9009 = 91 × 99.
   Find the largest palindrome made from the product of two 3-digit numbers which is less than N.

5. 2520 is the smallest number that can be divided by each of the numbers from 1 to 10 without any remainder.
   What is the smallest positive number that is evenly divisible(divisible with no remainder) by all of the numbers from 1 to N?

6. The sum of the squares of the first ten natural numbers is,
      1^2 + 2^2 + ... + 10^2 = 385
   The square of the sum of the first ten natural numbers is,
     (1 + 2 + ... + 10)^2 = 552 = 3025
   Hence the difference between the sum of the squares of the first ten natural numbers and the square of the sum is 3025 − 385 = 2640.
   Find the difference between the sum of the squares of the first N natural numbers and the square of the sum.

7. By listing the first six prime numbers: 2, 3, 5, 7, 11, and 13, we can see that the 6th prime is 13.
   What is the Nth prime number?
   
8. Find the consecutive k digits in a number N that have the largest product.

9. A Pythagorean triplet is a set of three natural numbers, a < b < c, for which,
    a^2 + b^2 = c^2
    There exists exactly one Pythagorean triplet for which a + b + c = 1000.
    Find the product abc.

10. Find sum of all prime numbers below 2 million.

11. In the given 20x20 grid, find 4 adjacent numbers (horizontally, vertically or diagonally) that have the largest product.

12. The sequence of triangle numbers is generated by adding the natural numbers. So the 7th triangle number would be 1 + 2 + 3 + 4 + 5 + 6 + 7 = 28. The first ten terms would be:

    1, 3, 6, 10, 15, 21, 28, 36, 45, 55, ...

    Let us list the factors of the first seven triangle numbers:

    1: 1
    3: 1,3
    6: 1,2,3,6
    10: 1,2,5,10
    15: 1,3,5,15
    21: 1,3,7,21
    28: 1,2,4,7,14,28
    We can see that 28 is the first triangle number to have over five divisors.

    What is the value of the first triangle number to have over five hundred divisors?
    
13. Work out the first 10 digits of the sum of the given hundred 50 digit numbers.  
    
14. The following iterative sequence is defined for the set of positive integers:
    n → n/2 (n is even)
    n → 3n + 1 (n is odd)
    Using the rule above and starting with 13, we generate the following sequence:
    13 → 40 → 20 → 10 → 5 → 16 → 8 → 4 → 2 → 1
    Which starting number, under one million, produces the longest chain?
    
15. Starting from top left corner of a 20x20 grid how many routes are there to reach the bottom left corner?

16. 2^15 = 32768 and the sum of its digits is 3 + 2 + 7 + 6 + 8 = 26.
    What is the sum of the digits of the number 2^1000?
    
17. If the numbers 1 through 1000 were written in words, how many total letters would be used?

18. By starting at the top of the triangle below and moving to adjacent numbers on the row below, the maximum total from top to bottom is 23.
   3
  7 4
 2 4 6
8 5 9 3

That is, 3 + 7 + 4 + 9 = 23.

Find the maximum total from top to bottom of the triangle below:

              75
             95 64
            17 47 82
           18 35 87 10
          20 04 82 47 65
         19 01 23 75 03 34
        88 02 77 73 07 63 67
       99 65 04 28 06 16 70 92
      41 41 26 56 83 40 80 70 33
     41 48 72 33 47 32 37 16 94 29
    53 71 44 65 25 43 91 52 97 51 14
   70 11 33 28 77 73 17 78 39 68 17 57
  91 71 52 38 17 14 91 43 58 50 27 29 48
 63 66 04 68 89 53 67 30 73 16 69 87 40 31
04 62 98 27 23 09 70 98 73 93 38 53 60 04 23

20. n! means n × (n − 1) × ... × 3 × 2 × 1
    For example, 10! = 10 × 9 × ... × 3 × 2 × 1 = 3628800,
    and the sum of the digits in the number 10! is 3 + 6 + 2 + 8 + 8 + 0 + 0 = 27.
    Find the sum of the digits in the number 100!
